var Expression=require("./expressions").Expression,Variable=require("./expressions").Variable,Term=require("./expressions").Term,Fraction=require("./fractions"),isInt=require("./helper").isInt,Equation=function(n,t){if(n instanceof Expression)if(this.lhs=n,t instanceof Expression)this.rhs=t;else if(t instanceof Fraction||isInt(t))this.rhs=new Expression(t);else throw new TypeError("Invalid Argument ("+t.toString()+"): Right-hand side must be of type Expression, Fraction or Integer.");else throw new TypeError("Invalid Argument ("+n.toString()+"): Left-hand side must be of type Expression.");};Equation.prototype.solveFor=function(n){var h,a,e,p,tt,t,f,ut,o,g,s,b,k,nt;if(!this.lhs._hasVariable(n)&&!this.rhs._hasVariable(n))throw new TypeError("Invalid Argument ("+n.toString()+"): Variable does not exist in the equation.");if(this._isLinear()||this._variableCanBeIsolated(n)){var rt=new Term(new Variable(n)),e=new Expression,u=new Expression;for(h=0;h<this.rhs.terms.length;h++)a=this.rhs.terms[h],a.canBeCombinedWith(rt)?e=e.subtract(a):u=u.add(a);for(h=0;h<this.lhs.terms.length;h++)a=this.lhs.terms[h],a.canBeCombinedWith(rt)?e=e.add(a):u=u.subtract(a);if(u=u.subtract(this.lhs.constant()),u=u.add(this.rhs.constant()),e.terms.length===0){if(e.constant().equalTo(u.constant()))return new Fraction(1,1);throw new EvalError("No Solution");}return(u=u.divide(e.terms[0].coefficient()),u.terms.length===0)?u.constant().reduce():(u._sort(),u)}if(e=this.lhs.copy(),e=e.subtract(this.rhs),e.terms.length===0){if(e.constant().valueOf()===0)return[new Fraction(1,1)];throw new EvalError("No Solution");}else{if(this._isQuadratic(n)){var y=e._quadraticCoefficients(),i=y.a,r=y.b,c=y.c,d=r.pow(2).subtract(i.multiply(c).multiply(4));return d.valueOf()>=0?d.valueOf()===0?[r.multiply(-1).divide(i.multiply(2)).reduce()]:d._squareRootIsRational()?(p=d.pow(.5),t=r.multiply(-1).subtract(p).divide(i.multiply(2)),f=r.multiply(-1).add(p).divide(i.multiply(2)),[t.reduce(),f.reduce()]):(p=Math.sqrt(d.valueOf()),i=i.valueOf(),r=r.valueOf(),t=(-r-p)/(2*i),f=(-r+p)/(2*i),[t,f]):[]}if(this._isCubic(n)){var y=e._cubicCoefficients(),i=y.a,r=y.b,c=y.c,w=y.d,l=i.multiply(r).multiply(c).multiply(w).multiply(18);if(l=l.subtract(r.pow(3).multiply(w).multiply(4)),l=l.add(r.pow(2).multiply(c.pow(2))),l=l.subtract(i.multiply(c.pow(3)).multiply(4)),l=l.subtract(i.pow(2).multiply(w.pow(2)).multiply(27)),tt=r.pow(2).subtract(i.multiply(c).multiply(3)),l.valueOf()===0)return tt.valueOf()===0?(t=r.multiply(-1).divide(i.multiply(3)),[t.reduce()]):(t=i.multiply(r).multiply(c).multiply(4),t=t.subtract(i.pow(2).multiply(w).multiply(9)),t=t.subtract(r.pow(3)),t=t.divide(i.multiply(tt)),f=i.multiply(w).multiply(9).subtract(r.multiply(c)).divide(tt.multiply(2)),[t.reduce(),f.reduce()]);if(ut=(3*(c/i)-Math.pow(r,2)/Math.pow(i,2))/3,o=2*Math.pow(r,3)/Math.pow(i,3),o=o-9*r*c/Math.pow(i,2),o=o+27*w/i,o=o/27,g=Math.pow(o,2)/4+Math.pow(ut,3)/27,g>0){var ct=-(o/2)+Math.sqrt(g),lt=Math.cbrt(ct),at=-(o/2)-Math.sqrt(g),vt=Math.cbrt(at),t=lt+vt-r/(3*i);return t<0?(s=Math.floor(t),t-s<1e-15&&(t=s)):t>0&&(s=Math.ceil(t),s-t<1e-15&&(t=s)),[t]}var h=Math.sqrt(Math.pow(o,2)/4-g),ft=Math.cbrt(h),it=Math.acos(-(o/(2*h))),et=-ft,ot=Math.cos(it/3),st=Math.sqrt(3)*Math.sin(it/3),ht=-(r/(3*i)),t=2*ft*Math.cos(it/3)-r/(3*i),f=et*(ot+st)+ht,v=et*(ot-st)+ht;return t<0?(s=Math.floor(t),t-s<1e-15&&(t=s)):t>0&&(s=Math.ceil(t),s-t<1e-15&&(t=s)),f<0?(b=Math.floor(f),f-b<1e-15&&(f=b)):f>0&&(b=Math.ceil(f),b-f<1e-15&&(f=b)),t<0?(k=Math.floor(v),v-k<1e-15&&(v=k)):v>0&&(k=Math.ceil(v),k-v<1e-15&&(v=k)),nt=[t,f,v],nt.sort(function(n,t){return n-t}),[nt[0],nt[1],nt[2]]}}};Equation.prototype.eval=function(n){return new Equation(this.lhs.eval(n),this.rhs.eval(n))};Equation.prototype.toString=function(n){return this.lhs.toString(n)+" = "+this.rhs.toString(n)};Equation.prototype.toTex=function(){return this.lhs.toTex()+" = "+this.rhs.toTex()};Equation.prototype._maxDegree=function(){var n=this.lhs._maxDegree(),t=this.rhs._maxDegree();return Math.max(n,t)};Equation.prototype._maxDegreeOfVariable=function(n){return Math.max(this.lhs._maxDegreeOfVariable(n),this.rhs._maxDegreeOfVariable(n))};Equation.prototype._variableCanBeIsolated=function(n){return this._maxDegreeOfVariable(n)===1&&this._noCrossProductsWithVariable(n)};Equation.prototype._noCrossProductsWithVariable=function(n){return this.lhs._noCrossProductsWithVariable(n)&&this.rhs._noCrossProductsWithVariable(n)};Equation.prototype._noCrossProducts=function(){return this.lhs._noCrossProducts()&&this.rhs._noCrossProducts()};Equation.prototype._onlyHasVariable=function(n){return this.lhs._onlyHasVariable(n)&&this.rhs._onlyHasVariable(n)};Equation.prototype._isLinear=function(){return this._maxDegree()===1&&this._noCrossProducts()};Equation.prototype._isQuadratic=function(n){return this._maxDegree()===2&&this._onlyHasVariable(n)};Equation.prototype._isCubic=function(n){return this._maxDegree()===3&&this._onlyHasVariable(n)};module.exports=Equation