var Fraction=require("./fractions"),isInt=require("./helper").isInt,GREEK_LETTERS=require("./helper").GREEK_LETTERS,Expression=function(n){if(this.constants=[],typeof n=="string"){var t=new Variable(n),i=new Term(t);this.terms=[i]}else if(isInt(n))this.constants=[new Fraction(n,1)],this.terms=[];else if(n instanceof Fraction)this.constants=[n],this.terms=[];else if(n instanceof Term)this.terms=[n];else if(typeof n=="undefined")this.terms=[];else throw new TypeError("Invalid Argument ("+n.toString()+"): Argument must be of type String, Integer, Fraction or Term.");},Variable;Expression.prototype.constant=function(){return this.constants.reduce(function(n,t){return n.add(t)},new Fraction(0,1))};Expression.prototype.simplify=function(){var n=this.copy();return n.terms=n.terms.map(function(n){return n.simplify()}),n._sort(),n._combineLikeTerms(),n._moveTermsWithDegreeZeroToConstants(),n._removeTermsWithCoefficientZero(),n.constants=n.constant().valueOf()===0?[]:[n.constant()],n};Expression.prototype.copy=function(){var n=new Expression;return n.constants=this.constants.map(function(n){return n.copy()}),n.terms=this.terms.map(function(n){return n.copy()}),n};Expression.prototype.add=function(n,t){var i=this.copy(),r,u;if(typeof n=="string"||n instanceof Term||isInt(n)||n instanceof Fraction)return r=new Expression(n),i.add(r,t);if(n instanceof Expression)u=n.copy().terms,i.terms=i.terms.concat(u),i.constants=i.constants.concat(n.constants),i._sort();else throw new TypeError("Invalid Argument ("+n.toString()+"): Summand must be of type String, Expression, Term, Fraction or Integer.");return t||t===undefined?i.simplify():i};Expression.prototype.subtract=function(n,t){var i=n instanceof Expression?n.multiply(-1):new Expression(n).multiply(-1);return this.add(i,t)};Expression.prototype.multiply=function(n,t){var r=this.copy(),c,f,e,h,s,l,u,a,i,v,o;if(typeof n=="string"||n instanceof Term||isInt(n)||n instanceof Fraction)return c=new Expression(n),r.multiply(c,t);if(n instanceof Expression){for(f=n.copy(),e=[],u=0;u<r.terms.length;u++){for(h=r.terms[u],i=0;i<f.terms.length;i++)s=f.terms[i],e.push(h.multiply(s,t));for(i=0;i<f.constants.length;i++)e.push(h.multiply(f.constants[i],t))}for(u=0;u<f.terms.length;u++)for(s=f.terms[u],i=0;i<r.constants.length;i++)e.push(s.multiply(r.constants[i],t));for(l=[],u=0;u<r.constants.length;u++)for(a=r.constants[u],i=0;i<f.constants.length;i++)v=f.constants[i],o=new Term,o=o.multiply(v,!1),o=o.multiply(a,!1),e.push(o);r.constants=l;r.terms=e;r._sort()}else throw new TypeError("Invalid Argument ("+n.toString()+"): Multiplicand must be of type String, Expression, Term, Fraction or Integer.");return t||t===undefined?r.simplify():r};Expression.prototype.divide=function(n,t){var i,u,f,r;if(n instanceof Fraction||isInt(n)){if(n.valueOf()===0)throw new EvalError("Divide By Zero");for(i=this.copy(),u=0;u<i.terms.length;u++)for(f=i.terms[u],r=0;r<f.coefficients.length;r++)f.coefficients[r]=f.coefficients[r].divide(n,t);return i.constants=i.constants.map(function(i){return i.divide(n,t)}),i}throw new TypeError("Invalid Argument ("+n.toString()+"): Divisor must be of type Fraction or Integer.");};Expression.prototype.pow=function(n,t){var i,r;if(isInt(n)){if(i=this.copy(),n===0)return(new Expression).add(1);for(r=1;r<n;r++)i=i.multiply(this,t);return i._sort(),t||t===undefined?i.simplify():i}throw new TypeError("Invalid Argument ("+n.toString()+"): Exponent must be of type Integer.");};Expression.prototype.eval=function(n,t){var i=new Expression;return i.constants=t?[this.constant()]:this.constants.slice(),this.terms.reduce(function(i,r){return i.add(r.eval(n,t),t)},i)};Expression.prototype.summation=function(n,t,i,r){for(var e,o=this.copy(),u=new Expression,f=t;f<i+1;f++)e={},e[n]=f,u=u.add(o.eval(e,r),r);return u};Expression.prototype.toString=function(n){for(var r,u,t="",i=0;i<this.terms.length;i++)r=this.terms[i],t+=(r.coefficients[0].valueOf()<0?" - ":" + ")+r.toString(n);for(i=0;i<this.constants.length;i++)u=this.constants[i],t+=(u.valueOf()<0?" - ":" + ")+u.abs().toString();return t.substring(0,3)===" - "?"-"+t.substring(3,t.length):t.substring(0,3)===" + "?t.substring(3,t.length):"0"};Expression.prototype.toTex=function(n){for(var r,u,t="",i=0;i<this.terms.length;i++)r=this.terms[i],t+=(r.coefficients[0].valueOf()<0?" - ":" + ")+r.toTex(n);for(i=0;i<this.constants.length;i++)u=this.constants[i],t+=(u.valueOf()<0?" - ":" + ")+u.abs().toTex();return t.substring(0,3)===" - "?"-"+t.substring(3,t.length):t.substring(0,3)===" + "?t.substring(3,t.length):"0"};Expression.prototype._removeTermsWithCoefficientZero=function(){return this.terms=this.terms.filter(function(n){return n.coefficient().reduce().numer!==0}),this};Expression.prototype._combineLikeTerms=function(){function e(n,t){for(var i=0;i<t.length;i++)if(n.canBeCombinedWith(t[i]))return!0;return!1}for(var n,i,r,u=[],f=[],t=0;t<this.terms.length;t++)if(n=this.terms[t],e(n,f))continue;else{for(i=t+1;i<this.terms.length;i++)r=this.terms[i],n.canBeCombinedWith(r)&&(n=n.add(r));u.push(n);f.push(n)}return this.terms=u,this};Expression.prototype._moveTermsWithDegreeZeroToConstants=function(){for(var n,r=[],t=new Fraction(0,1),i=0;i<this.terms.length;i++)n=this.terms[i],n.variables.length===0?t=t.add(n.coefficient()):r.push(n);return this.constants.push(t),this.terms=r,this};Expression.prototype._sort=function(){function n(n,t){var i=n.maxDegree(),r=t.maxDegree(),u,f;return i===r?(u=n.variables.length,f=t.variables.length,f-u):r-i}return this.terms=this.terms.sort(n),this};Expression.prototype._hasVariable=function(n){for(var t=0;t<this.terms.length;t++)if(this.terms[t].hasVariable(n))return!0;return!1};Expression.prototype._onlyHasVariable=function(n){for(var t=0;t<this.terms.length;t++)if(!this.terms[t].onlyHasVariable(n))return!1;return!0};Expression.prototype._noCrossProductsWithVariable=function(n){for(var i,t=0;t<this.terms.length;t++)if(i=this.terms[t],i.hasVariable(n)&&!i.onlyHasVariable(n))return!1;return!0};Expression.prototype._noCrossProducts=function(){for(var t,n=0;n<this.terms.length;n++)if(t=this.terms[n],t.variables.length>1)return!1;return!0};Expression.prototype._maxDegree=function(){return this.terms.reduce(function(n,t){return Math.max(n,t.maxDegree())},1)};Expression.prototype._maxDegreeOfVariable=function(n){return this.terms.reduce(function(t,i){return Math.max(t,i.maxDegreeOfVariable(n))},1)};Expression.prototype._quadraticCoefficients=function(){for(var n,u,t,i=new Fraction(0,1),r=0;r<this.terms.length;r++)n=this.terms[r],t=n.maxDegree()===2?n.coefficient().copy():t,i=n.maxDegree()===1?n.coefficient().copy():i;return u=this.constant(),{a:t,b:i,c:u}};Expression.prototype._cubicCoefficients=function(){for(var n,f,t,i=new Fraction(0,1),r=new Fraction(0,1),u=0;u<this.terms.length;u++)n=this.terms[u],t=n.maxDegree()===3?n.coefficient().copy():t,i=n.maxDegree()===2?n.coefficient().copy():i,r=n.maxDegree()===1?n.coefficient().copy():r;return f=this.constant(),{a:t,b:i,c:r,d:f}};Term=function(n){if(n instanceof Variable)this.variables=[n.copy()];else if(typeof n=="undefined")this.variables=[];else throw new TypeError("Invalid Argument ("+n.toString()+"): Term initializer must be of type Variable.");this.coefficients=[new Fraction(1,1)]};Term.prototype.coefficient=function(){return this.coefficients.reduce(function(n,t){return n.multiply(t)},new Fraction(1,1))};Term.prototype.simplify=function(){var n=this.copy();return n.coefficients=[this.coefficient()],n.combineVars(),n.sort()};Term.prototype.combineVars=function(){for(var n,r,u,f,t={},i=0;i<this.variables.length;i++)n=this.variables[i],n.variable in t?t[n.variable]+=n.degree:t[n.variable]=n.degree;r=[];for(u in t)f=new Variable(u),f.degree=t[u],r.push(f);return this.variables=r,this};Term.prototype.copy=function(){var n=new Term;return n.coefficients=this.coefficients.map(function(n){return n.copy()}),n.variables=this.variables.map(function(n){return n.copy()}),n};Term.prototype.add=function(n){if(n instanceof Term&&this.canBeCombinedWith(n)){var t=this.copy();return t.coefficients=[t.coefficient().add(n.coefficient())],t}throw new TypeError("Invalid Argument ("+n.toString()+"): Summand must be of type String, Expression, Term, Fraction or Integer.");};Term.prototype.subtract=function(n){if(n instanceof Term&&this.canBeCombinedWith(n)){var t=this.copy();return t.coefficients=[t.coefficient().subtract(n.coefficient())],t}throw new TypeError("Invalid Argument ("+n.toString()+"): Subtrahend must be of type String, Expression, Term, Fraction or Integer.");};Term.prototype.multiply=function(n,t){var i=this.copy(),r;if(n instanceof Term)i.variables=i.variables.concat(n.variables),i.coefficients=n.coefficients.concat(i.coefficients);else if(isInt(n)||n instanceof Fraction)r=isInt(n)?new Fraction(n,1):n,i.variables.length===0?i.coefficients.push(r):i.coefficients.unshift(r);else throw new TypeError("Invalid Argument ("+n.toString()+"): Multiplicand must be of type String, Expression, Term, Fraction or Integer.");return t||t===undefined?i.simplify():i};Term.prototype.divide=function(n,t){if(isInt(n)||n instanceof Fraction){var i=this.copy();return i.coefficients=i.coefficients.map(function(i){return i.divide(n,t)}),i}throw new TypeError("Invalid Argument ("+n.toString()+"): Argument must be of type Fraction or Integer.");};Term.prototype.eval=function(n,t){for(var i,u,r,f=this.copy(),s=Object.keys(n),e=f.coefficients.reduce(function(n,i){return n.multiply(i,t)},new Expression(1)),o=0;o<f.variables.length;o++){if(i=f.variables[o],i.variable in n)if(r=n[i.variable],r instanceof Fraction||r instanceof Expression)u=r.pow(i.degree);else if(isInt(r))u=Math.pow(r,i.degree);else throw new TypeError("Invalid Argument ("+r+"): Can only evaluate Expressions or Fractions.");else u=new Expression(i.variable).pow(i.degree);e=e.multiply(u,t)}return e};Term.prototype.hasVariable=function(n){for(var t=0;t<this.variables.length;t++)if(this.variables[t].variable===n)return!0;return!1};Term.prototype.maxDegree=function(){return this.variables.reduce(function(n,t){return Math.max(n,t.degree)},1)};Term.prototype.maxDegreeOfVariable=function(n){return this.variables.reduce(function(t,i){return i.variable===n?Math.max(t,i.degree):t},1)};Term.prototype.canBeCombinedWith=function(n){var t=this.variables,u=n.variables,f,i,r;if(t.length!=u.length)return!1;for(f=0,i=0;i<t.length;i++)for(r=0;r<u.length;r++)t[i].variable===u[r].variable&&t[i].degree===u[r].degree&&(f+=1);return f===t.length};Term.prototype.onlyHasVariable=function(n){for(var t=0;t<this.variables.length;t++)if(this.variables[t].variable!=n)return!1;return!0};Term.prototype.sort=function(){function n(n,t){return t.degree-n.degree}return this.variables=this.variables.sort(n),this};Term.prototype.toString=function(n){for(var i,u=n&&n.implicit,t="",r=0;r<this.coefficients.length;r++)i=this.coefficients[r],(i.abs().numer!==1||i.abs().denom!==1)&&(t+=" * "+i.toString());return t=this.variables.reduce(function(n,t){if(u&&!!n){var i=t.toString();return!i?n:n+"*"+i}return n.concat(t.toString())},t),t=t.substring(0,3)===" * "?t.substring(3,t.length):t,t.substring(0,1)==="-"?t.substring(1,t.length):t};Term.prototype.toTex=function(n){var n=n===undefined?{}:n,i,t,r,u;for(n.multiplication=(("multiplication"in n))?n.multiplication:"cdot",i=" \\"+n.multiplication+" ",t="",r=0;r<this.coefficients.length;r++)u=this.coefficients[r],(u.abs().numer!==1||u.abs().denom!==1)&&(t+=i+u.toTex());return t=this.variables.reduce(function(n,t){return n.concat(t.toTex())},t),t=t.substring(0,i.length)===i?t.substring(i.length,t.length):t,t=t.substring(0,1)==="-"?t.substring(1,t.length):t,t.substring(0,7)==="\\frac{-"?"\\frac{"+t.substring(7,t.length):t};Variable=function(n){if(typeof n=="string")this.variable=n,this.degree=1;else throw new TypeError("Invalid Argument ("+n.toString()+"): Variable initalizer must be of type String.");};Variable.prototype.copy=function(){var n=new Variable(this.variable);return n.degree=this.degree,n};Variable.prototype.toString=function(){var n=this.degree,t=this.variable;return n===0?"":n===1?t:t+"^"+n};Variable.prototype.toTex=function(){var t=this.degree,n=this.variable;return GREEK_LETTERS.indexOf(n)>-1&&(n="\\"+n),t===0?"":t===1?n:n+"^{"+t+"}"};module.exports={Expression:Expression,Term:Term,Variable:Variable}