"use strict";var Lexer=require("./lexer"),Expression=require("./expressions").Expression,Fraction=require("./fractions"),Equation=require("./equations"),Parser=function(){this.lexer=new Lexer;this.current_token=null};Parser.prototype.update=function(){this.current_token=this.lexer.token()};Parser.prototype.match=function(n){if(this.current_token===null)return n==="epsilon";switch(n){case"plus":return this.current_token.type==="OPERATOR"&&this.current_token.value==="PLUS";case"minus":return this.current_token.type==="OPERATOR"&&this.current_token.value==="MINUS";case"multiply":return this.current_token.type==="OPERATOR"&&this.current_token.value==="MULTIPLY";case"power":return this.current_token.type==="OPERATOR"&&this.current_token.value==="POWER";case"divide":return this.current_token.type==="OPERATOR"&&this.current_token.value==="DIVIDE";case"equal":return this.current_token.type==="OPERATOR"&&this.current_token.value==="EQUALS";case"lparen":return this.current_token.type==="PAREN"&&this.current_token.value==="L_PAREN";case"rparen":return this.current_token.type==="PAREN"&&this.current_token.value==="R_PAREN";case"num":return this.current_token.type==="NUMBER";case"id":return this.current_token.type==="IDENTIFIER";default:return!1}};Parser.prototype.parse=function(n){return this.lexer.input(n),this.update(),this.parseEqn()};Parser.prototype.parseEqn=function(){var n=this.parseExpr(),t;if(this.match("equal"))return this.update(),t=this.parseExpr(),new Equation(n,t);if(this.match("epsilon"))return n;throw new SyntaxError("Unbalanced Parenthesis");};Parser.prototype.parseExpr=function(){var n=this.parseTerm();return this.parseExprRest(n)};Parser.prototype.parseExprRest=function(n){var t,i;if(this.match("plus")){if(this.update(),t=this.parseTerm(),n===undefined||t===undefined)throw new SyntaxError("Missing operand");return this.parseExprRest(n.add(t))}return this.match("minus")?(this.update(),i=this.parseTerm(),n===undefined?this.parseExprRest(i.multiply(-1)):this.parseExprRest(n.subtract(i))):n};Parser.prototype.parseTerm=function(){var n=this.parseFactor();return this.parseTermRest(n)};Parser.prototype.parseTermRest=function(n){var i,r,u,t;return this.match("multiply")?(this.update(),i=this.parseFactor(),n.multiply(this.parseTermRest(i))):this.match("power")?(this.update(),r=this.parseFactor(),this.parseTermRest(n.pow(parseInt(r.toString())))):this.match("divide")?(this.update(),u=this.parseFactor(),this.parseTermRest(n.divide(this.convertToFraction(u)))):this.match("epsilon")?n:(t=this.parseFactor(),t===undefined?n:n.multiply(this.parseTermRest(t)))};Parser.prototype.convertToFraction=function(n){if(n.terms.length>0)throw new TypeError("Invalid Argument ("+n.toString()+"): Divisor must be of type Integer or Fraction.");else{var t=n.constants[0];return new Fraction(t.numer,t.denom)}};Parser.prototype.parseFactor=function(){var n,t,i;if(this.match("num"))return n=this.parseNumber(),this.update(),n;if(this.match("id"))return t=new Expression(this.current_token.value),this.update(),t;if(this.match("lparen")){if(this.update(),i=this.parseExpr(),this.match("rparen"))return this.update(),i;throw new SyntaxError("Unbalanced Parenthesis");}else return undefined};Parser.prototype.parseNumber=function(){if(parseInt(this.current_token.value)==this.current_token.value)return new Expression(parseInt(this.current_token.value));var t=this.current_token.value.split("."),i=t[1].length,n=Math.pow(10,i),r=parseFloat(this.current_token.value);return new Expression(parseInt(r*n)).divide(n)};module.exports=Parser